package org.ssssssss.magicboot.controller;
        import com.alibaba.fastjson.JSON;
        import com.alibaba.fastjson.JSONArray;
        import com.alibaba.fastjson.JSONObject;
        import com.xxl.job.core.context.XxlJobHelper;
        import org.slf4j.Logger;
        import org.slf4j.LoggerFactory;
        import org.springframework.web.bind.annotation.PostMapping;
        import org.springframework.web.bind.annotation.RequestMapping;
        import org.springframework.web.bind.annotation.RestController;
        import org.ssssssss.magicboot.fxapi.HttpClientResult;
        import org.ssssssss.magicboot.fxapi.HttpClientUtils;
        import org.ssssssss.magicboot.fxapi.XKTokenAccess;
        import org.ssssssss.magicboot.zdyutils.FXHTTP;
        import org.ssssssss.magicboot.zdyutils.FXTIC;
        import org.ssssssss.magicboot.zdyutils.GcjJson;
        import org.ssssssss.magicboot.zdyutils.MagicApi;

        import java.text.SimpleDateFormat;
        import java.util.HashMap;
        import java.util.LinkedHashMap;
        import java.util.Map;

/**
 * 人员同步
 */
@RestController
@RequestMapping("/User")

public class UsceController {
    private final Logger log = LoggerFactory.getLogger(UsceController.class);

    public static void main(String[] args) throws Exception {
       // new UsceController().getUserData();
        new UsceController().saveSynUser();
    }

    @PostMapping("/getUserData")
    public void getUserData() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = sdf.format(System.currentTimeMillis() - (1000 * 60 * 62 * 24));
        //  time = "2024-05-01";
        String sendUrl = "http://192.168.31.121:8022/ierp/kapi/v2/f9w5/base/bos_user/userQuery";
        Map<String, String> headers = new HashMap<String, String>();
        String token = "2095350818281620480_YjTXXBgsnPw1njDkmd7vEw6DCpYTl3AXecvkvO3gelJu41WbhuxYION9M4OB2B722b5zQwcBxmT9OyCbMrW8DqFpCIz9iHmTZRRC01";
        headers.put("accessToken",  token);//放token

        JSONObject params = new JSONObject();

        JSONObject datajson = new JSONObject();
        datajson.put("createtime","2012-02-26 11:04:43");
            JSONArray arr = new JSONArray();
        String[] strings = {
                "ZHY005.001.004"
        };

        // 将字符串添加到 JSONArray 中
        for (String str : strings) {
            arr.add(str);
        }



        datajson.put("dpt_number",arr);


        params.put("data",datajson);
        params.put("pageNo",1);
        params.put("pageSize",1000);


        HttpClientResult rtn = HttpClientUtils.doPostJson(sendUrl, headers, params.toJSONString());
        String resStr = rtn.getContent();
        JSONObject resjs = JSONObject.parseObject(resStr);
        if (resjs!=null){
            if("0".equals(resjs.getString("errorCode"))){//查询成功
                JSONObject data =  resjs.getJSONObject("data");
                  System.out.println("查询人员总数量" + data.getInteger("totalCount"));
                JSONArray resJson =  data.getJSONArray("rows");

                System.out.println("待同步人员数量" + resJson.size());

                for (int i = 0; i < resJson.size(); i++) {
                    JSONObject str = resJson.getJSONObject(i);
                    //ERPID
                    String dataId = GcjJson.getNodeValue(str, "JSON.id") != null ? GcjJson.getNodeValue(str, "JSON.id").toString() : "";
                    //ERP人员编码
                    String number = GcjJson.getNodeValue(str, "JSON.number") != null ? GcjJson.getNodeValue(str, "JSON.number").toString() : "";

                    String name = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";

                    String endtime = GcjJson.getNodeValue(str, "JSON.modifytime") != null ? GcjJson.getNodeValue(str, "JSON.modifytime").toString() : "";

                    String syn_type = "0";//同步类型 0新增 1修改 2删除
                    log.info("-------------------开始执行人员" + i + " -------------------" + number);
                    XxlJobHelper.log("-------------------开始执行人员" + i + " -------------------" + number);

                    Boolean sendFlag = false;
                    StringBuffer stringBuffer = new StringBuffer();

                    try {
                        boolean tbflag = false;
                        //验证数据是否已存在
                        JSONObject dataSyn = MagicApi.getSendSYNUser("user", syn_type, dataId);

                        if (dataSyn != null && endtime.equals(dataSyn.getString("mark"))) {
                            log.info("数据已存在-" + name);
                            XxlJobHelper.log("--数据已存在---" + name);
                            tbflag = true;
                        }

                        if (tbflag) {
                            continue;
                        }
                        log.info("人员待同步数据-" + i + " ------" + name);

                        JSONObject jsonObjectData = new JSONObject();
                        jsonObjectData.put("send_type", "user"); //业务类型
                        jsonObjectData.put("send_syn", syn_type); //同步类型 0新增 1修改 2删除
                        jsonObjectData.put("dsf_id", dataId);//数据id
                        jsonObjectData.put("dsfzhu_id", dataId);//数据id
                        jsonObjectData.put("send_status", 3);//同步状态 true同步成功 false同步失败 3待同步
                        jsonObjectData.put("dsf_code", name);//数据名称
                        jsonObjectData.put("mark", endtime);//标识
                        jsonObjectData.put("dsf_json", str.toJSONString());//标识

                        MagicApi.saveSendSYNUser(jsonObjectData);
                    } catch (Exception e) {
                        continue;
                    }

                }


            }
        }

    }

    //@PostMapping("/getSynProduct")
    public void saveSynUser() throws Exception {
        FXHTTP fxapi = new FXHTTP();
        String resJsonStr = MagicApi.getWNRES("http://127.0.0.1:18088/syn/queryuser?sendType=user&sendStatus=3", "");
        JSONObject resJson = JSON.parseObject(resJsonStr);
        if (resJson != null) {
            log.info("待同步人员数" + resJson.getJSONArray("data").size());
            for (int i = 0; i < resJson.getJSONArray("data").size(); i++) {
                XKTokenAccess xktonken = new XKTokenAccess();
                JSONObject getData = resJson.getJSONArray("data").getJSONObject(i);
                JSONObject str = getData.getJSONObject("dsfJson");
                String syn_type = "0";//同步类型 0新增 1修改 2删除
                Boolean sendFlag = false;
                StringBuffer stringBuffer = new StringBuffer();
                boolean tbflag = false;
                // 构建json
                JSONObject obj = new JSONObject();
                LinkedHashMap map = new LinkedHashMap<String, Object>();
                Boolean flag = true;
                //ID
                String dataId = GcjJson.getNodeValue(str, "JSON.id") != null ? GcjJson.getNodeValue(str, "JSON.id").toString() : "";
                //编码
                String number = GcjJson.getNodeValue(str, "JSON.number") != null ? GcjJson.getNodeValue(str, "JSON.number").toString() : "";

                String name = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";

                //最后修改时间
                String endtime = GcjJson.getNodeValue(str, "JSON.modifytime") != null ? GcjJson.getNodeValue(str, "JSON.modifytime").toString() : "";
                //性别
                String gender = GcjJson.getNodeValue(str, "JSON.gender") != null ? GcjJson.getNodeValue(str, "JSON.gender").toString() : "";

                String email = GcjJson.getNodeValue(str, "JSON.email") != null ? GcjJson.getNodeValue(str, "JSON.email").toString() : "";

                String phone = GcjJson.getNodeValue(str, "JSON.phone") != null ? GcjJson.getNodeValue(str, "JSON.phone").toString() : "";

               //状态
                String enable = GcjJson.getNodeValue(str, "JSON.enable") != null ? GcjJson.getNodeValue(str, "JSON.enable").toString() : "";


                JSONArray entryentity =  str.getJSONArray("entryentity");
                String deptNumber = "";
                if(entryentity!=null){
                    JSONObject deptobj = (JSONObject) entryentity.get(0);
                     deptNumber = deptobj.getString("dpt_number");
                }


                try{
                    JSONObject dataSyn = MagicApi.getSendSYNDataUser("user", syn_type, dataId,"3");
                    if (dataSyn != null && dataId.equals(dataSyn.getString("dsfId")) && endtime.equals(dataSyn.getString("mark")) ) {
                        log.info("数据已存在-" + name);
                        XxlJobHelper.log("--数据已存在---" + name);
                        tbflag = true;
                    }
                    if (tbflag) {
                        continue;
                    }

                    //查询人员CRMID
                    String crmId = fxapi.getDataBYID("PersonnelObj", "field_T1xid__c", number, "JSON.data.dataList[0]._id");
                    if (crmId != null && !crmId.equals("")) {
                        //人员id
                        map.put("body.data.object_data._id", crmId);
                        flag=false;
                    }
                    String crmdeptID = "999999";
                    if (deptNumber!=""){
                         crmdeptID = fxapi.getDataBYID("DepartmentObj", "field_Vj6sf__c", deptNumber, "JSON.data.dataList[0]._id");
                        System.out.println(crmdeptID);
                    }

                    map.put("body.data.object_data.phone", phone);
                    map.put("body.data.object_data.name", name);
                    map.put("body.data.object_data.full_name", name);
                    map.put("body.data.object_data.erp_id__c", dataId);//ID
                    map.put("body.data.object_data.field_T1xid__c", number);//编码
                    map.put("body.data.object_data.user_name", phone);
                    map.put("body.data.object_data.email", email);

                    if(enable.equals("2")){
                        map.put("body.data.object_data.status", "1");
                        map.put("body.data.object_data.is_pause_login", true);
                    }else {
                        map.put("body.data.object_data.status", "0");
                        map.put("body.data.object_data.is_pause_login", false);
                    }
                    if(gender.equals("1")){
                        map.put("body.data.object_data.sex", "M");

                    }if(gender.equals("2")){
                        map.put("body.data.object_data.sex", "F");

                    }else {
                        map.put("body.data.object_data.sex", "P");
                    }
                    map.put("body.data.object_data.main_department[0]", crmdeptID);//主属部门

                    map.put("body.data.object_data.dataObjectApiName", "PersonnelObj");

                    map.put("body.corpId", FXTIC.CORPID);
                    map.put("body.corpAccessToken", xktonken.getCorpAccessToken().getCorpAccessToken());
                    map.put("body.currentOpenUserId", FXTIC.CURRENTOPENUSERID);
                    for (Object key : map.keySet()) {
                        GcjJson.setNodeValue(obj, key.toString(), map.get(key));
                    }
                    log.info("--请求json---" + obj);
                    XxlJobHelper.log("--请求json---" + obj);

                }catch  (Exception e) {
                    sendFlag = true;
                    stringBuffer.append("参数解析错误，请联系开发人员");
                    e.printStackTrace();
                }
                getSynDataSave(stringBuffer,sendFlag,flag,fxapi,dataId,name,obj,getData);

            }
        }
    }
    /**
     * 写数据
     */
    public void getSynDataSave(StringBuffer stringBuffer,Boolean sendFlag,Boolean flag,FXHTTP fxapi,String dataId,String nameData,JSONObject obj,JSONObject str) {
        String syn_type = "0";//同步类型 0新增 1修改 2删除
        String res_url = "";
        String res_param = "";
        String res = "";
        try {
            if (flag) {
                res = fxapi.saveV2Obj(obj);
                res_url=FXTIC.URL_FX_CREATE;
            } else {
                syn_type = "1";
                res = fxapi.updateV2Obj(obj);
                res_url=FXTIC.URL_FX_UPDATE;
            }
            res_param=obj.toJSONString();
            log.info("返回值："+res);
            JSONObject resjs = JSON.parseObject(res);
            if (resjs != null && "0".equals(resjs.getString("errorCode"))) {

            } else {
                sendFlag = true;
                stringBuffer.append(resjs.getString("errorMessage") + "");
            }
        } catch (Exception e) {
            sendFlag = true;
            stringBuffer.append("纷享销客接口调用失败,请检查网络配置");
        }
        JSONObject sendData = new JSONObject();
        sendData.put("send_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
        sendData.put("crm_code", nameData);//数据名称
        sendData.put("send_id", str.getString("sendId")); //send_id
        MagicApi.updateSendSYUPDATENUser(sendData);

        JSONObject logData = new JSONObject();
        logData.put("log_type", "user"); //业务类型
        logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
        logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
        logData.put("data_id", dataId);//数据id
        logData.put("data_name", nameData);//数据名称
        logData.put("res_body", "同步成功");//返回值
        logData.put("res_url", res_url);//
        logData.put("res_param", res_param);//
        logData.put("res_res", res);//
        if (sendFlag) {
            logData.put("res_body", stringBuffer.toString());//返回值
        }
        //写入传输日志
        MagicApi.saveUserLog(logData);
    }





}
