package org.ssssssss.magicboot.entity;

import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.List;

public class Filter {
    @JsonProperty("operator")
    private String operator;
    @JsonProperty("field_name")
    private String fieldName;
    @JsonProperty("field_values")
    private List<String> fieldValues;

    // 构造方法
    public Filter(String operator, String fieldName, List<String> fieldValues) {
        this.operator = operator;
        this.fieldName = fieldName;
        this.fieldValues = fieldValues;
    }

    // Getter 和 Setter 方法
    public String getOperator() {
        return operator;
    }

    public void setOperator(String operator) {
        this.operator = operator;
    }

    public String getFieldName() {
        return fieldName;
    }

    public void setFieldName(String fieldName) {
        this.fieldName = fieldName;
    }

    public List<String> getFieldValues() {
        return fieldValues;
    }

    public void setFieldValues(List<String> fieldValues) {
        this.fieldValues = fieldValues;
    }

    // 方便打印的 toString 方法
    @Override
    public String toString() {
        return "Filter{" +
                "operator='" + operator + '\'' +
                ", field_name='" + fieldName + '\'' +
                ", field_values=" + fieldValues +
                '}';
    }
}
